#!/bin/sh
RAD_RET=255
RAD_F_LOCK="/tmp/synoradius.lock"
RAD_F_PID="/var/packages/RadiusServer/target/var/run/radiusd/radiusd.pid"
RAD_F_LISTEN="/usr/local/synoradius/rad_listen"

PATH_IFCFG="/sbin/ifconfig"
PATH_AWK="/bin/awk"
PATH_CUT="/bin/cut"
PATH_SORT="/bin/sort"
PATH_UNIQ="/bin/uniq"

UseLocal() {
	local BACK_END_TYPE=`/usr/syno/bin/synogetkeyvalue  /usr/local/synoradius/synoconf back_end_type`

	if [ "xlocal" != "x${BACK_END_TYPE}" ]; then
		echo "\$INCLUDE /usr/local/synoradius/rad_site_def_local" > "/usr/local/synoradius/rad_site_def"
		echo "\$INCLUDE /usr/local/synoradius/rad_site_inn_local" > "/usr/local/synoradius/rad_site_inn"
		/usr/syno/bin/synosetkeyvalue /usr/local/synoradius/synoconf back_end_type "local"
	fi
	return 0
}

SetListen() {
	local RAD_LOCAL_IP=`$PATH_IFCFG | $PATH_AWK '/inet /{print$2}' | $PATH_CUT -d ":" -f 2 | $PATH_SORT | $PATH_UNIQ`
	echo "" > $RAD_F_LISTEN

	for LOCAL_IP in $RAD_LOCAL_IP; do
		echo -e "listen {" >> $RAD_F_LISTEN
		echo -e "\ttype = auth" >> $RAD_F_LISTEN
		echo -e "\tipaddr = ${LOCAL_IP}" >> $RAD_F_LISTEN
		echo -e "\t\$INCLUDE /usr/local/synoradius/rad_port_auth" >> $RAD_F_LISTEN
		echo -e "}" >> $RAD_F_LISTEN
	done
	return 0
}

StartRAD() {
	for i in `seq 1 1 3`; do
		sleep 3
		/var/packages/RadiusServer/target/sbin/radiusd
		if [ 0 -eq $? ]; then
			return 0
		fi
	done
	return 255
}

StopRAD() {
	if [ -f $RAD_F_PID ]; then
		kill -TERM `cat ${RAD_F_PID}`
	fi
}

ReloadRAD() {
	if [ -f $RAD_F_PID ]; then
		kill -HUP `cat ${RAD_F_PID}`
	fi
}

{
flock -x 0

case $1 in
	start)
		SetListen
		StartRAD
		RAD_RET=$?
	;;
	uselocal)
		UseLocal
		ReloadRAD
		RAD_RET=$?
	;;
	restart)
		StopRAD
		SetListen
		StartRAD
		RAD_RET=$?
	;;
	reload)
		ReloadRAD
		RAD_RET=0
	;;
esac

flock -u 0
} 0<>$RAD_F_LOCK
exit $RAD_RET

