#!/bin/sh

RADIUS_SH="/var/packages/RadiusServer/target/syno_bin/RadiusServer.sh"
RADIUSD_CERT_PATH="/usr/local/etc/certificate/RadiusServer/radiusd"
TARGET_CONF="/usr/local/synoradius"

reload_radiusd()
{
	${RADIUS_SH} restart
}

set_ca_path()
{
	echo "" > ${TARGET_CONF}/rad_ca_cert
	if [ -f ${RADIUSD_CERT_PATH}/syno-ca-cert.pem ]; then
		echo "ca_file = ${RADIUSD_CERT_PATH}/syno-ca-cert.pem" >> ${TARGET_CONF}/rad_ca_cert
	elif [ -f ${RADIUSD_CERT_PATH}/chain.pem ]; then
		echo "#trust ca is set to the intermediate-ca: chain.pem" >> ${TARGET_CONF}/rad_ca_cert
		echo "ca_file = ${RADIUSD_CERT_PATH}/chain.pem" >> ${TARGET_CONF}/rad_ca_cert
	else
		echo "#ca and intermediate-ca both not exist" >> ${TARGET_CONF}/rad_ca_cert
		echo "#ca_file = ${RADIUSD_CERT_PATH}/syno-ca-cert.pem" >> ${TARGET_CONF}/rad_ca_cert
	fi
}

case "$1" in 
	radiusd)
		set_ca_path
		reload_radiusd
		;;
	reload_conf)
		set_ca_path
		;;
	*)
		echo "usage: $0 {radiusd}"
		exit 1
		;;
esac
