#!/bin/sh

#include common scripts
FILE_RADIUSSERVER_INC_SCRIPT=/usr/local/libexec/RadiusServerCommon.sh
. ${FILE_RADIUSSERVER_INC_SCRIPT}

#At begining, acquire package settings
PackageInfoGet;

RAD_RET=255

case $1 in
	--sdk-mod-ver)
		#Print SDK support version
		echo ${RADIUSSERVER_PKG_MODVER};
		RAD_RET=0
	;;
	--name)
		#Print package name
		echo ${RADIUSSERVER_PKG_NAME};
		RAD_RET=0
	;;
	--pkg-ver)
		#Print package name
		echo ${RADIUSSERVER_PKG_VERSION};
		RAD_RET=0
	;;
	--vendor)
		#Printf package vendor
		echo ${RADIUSSERVER_PKG_VENDOR};
		RAD_RET=0
	;;
	--pre)
		#Actions before share set
		RAD_RET=0
	;;
	--post)
		synobootseq --is-ready
		if [ 1 -eq $? ]; then
			exit 0
		fi

		PackageEnableGet
		if [ 0 -eq $? ]; then
			RadiusServerUseLocal
			RAD_RET=$?
		else
			RAD_RET=0
		fi
	;;
	*)
		echo "Usage: $0 --sdk_mod_ver|--name|--pkg_ver|--vendor|--pre|--post"
	;;
esac
exit $RAD_RET
